class UserPresenter
  attr_reader :user

  delegate :first_name, :last_name, :email,
    to: :user

  def initialize(user, template)
    @user, @template = user, template
  end

  def full_name
    "#{user.first_name} #{user.last_name}"
  end

  def linked_full_name
    link_to full_name, user
  end

  def article_list
    render partial: "shared/article", collection: @user.articles
  end

  def method_missing(*args, &block)
    @template.send(*args, &block)
  end
end
